package com.servlet;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
/**
 * Servlet implementation class for Servlet: LoginServlet
 *
 */
 public class LoginServlet extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#HttpServlet()
	 */
	
	Connection conn=null;
	 PreparedStatement stmt=null;
	 ResultSet rs=null;
	 String query1="select password,designation,jno from sch2.staff_user where pid=? and designation=?";
	 String query2="select password from sch2.super_user where sid=?";
	 String query3="select password,designation from sch2.common_user where uid=? and designation=?";
	 String query4="insert into sch2.log_reg(uid,ldate,login,category) values(?,?,?,?)";
	 
	public LoginServlet() {
		
		
	}   	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	HttpSession session;
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		session=request.getSession();
		if(session.isNew())session.setMaxInactiveInterval(-1);
		com.bean.LogonBean loginbean;
		loginbean=(com.bean.LogonBean)session.getAttribute("loginbean");
		if(loginbean!=null)
		{
		if(loginbean.getId()!=null)
			doPost(request,response);
		else
		{
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/index.jsp");
			dispatcher.forward(request,response);
			
		}
		}
		else
		{
			
		}
	}  	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	
	 
	
	
	
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		session=request.getSession();
		if(session.isNew())session.setMaxInactiveInterval(-1);
		com.bean.LogonBean loginbean;
		loginbean=(com.bean.LogonBean)session.getAttribute("loginbean");
		if(loginbean.getId()!=null)
		{
			String id=loginbean.getId();
			loginbean.setNo(loginbean.getNo()+1);
			response.getWriter().println("hi "+id);

			String nextJSP = "/finishlogin.jsp";
			RequestDispatcher dispatcher = getServletContext().getRequestDispatcher(nextJSP);
			dispatcher.forward(request,response);
			
	
		
		}
		else
		{
			
try{
				
				Class.forName("com.ibm.db2.jcc.DB2Driver");
				conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
						
			}
			catch(Exception e){
				response.getWriter().println(e); 
			}

			
			String id=request.getParameter("id");
			String pwd=request.getParameter("pwd");
			int category=Integer.parseInt(request.getParameter("category"));
			String key=request.getParameter("key");
			String msg="";
			
			try{
				String key_super="select msg from sch2.super_user where sid=?";
				String key_staff="select msg from sch2.staff_user where pid=? and designation=?";
				String key_common="select msg from sch2.common_user where uid=? and designation=?";
				if(category==0){
					stmt=conn.prepareStatement(key_super);
					stmt.setString(1,id);
				}
				if(category>=1 && category<=3){
					stmt=conn.prepareStatement(key_staff);
					stmt.setString(1,id);
					stmt.setInt(2,category);
				}
				if(category==4 || category==5){
					stmt=conn.prepareStatement(key_common);
					stmt.setString(1,id);
					stmt.setInt(2,category);
				}
				ResultSet rs1=stmt.executeQuery();
				if(rs1.next())msg=rs1.getString(1);
				
			}
			catch(Exception e){}
			
			String enc_key=new com.security.rsa.RSA().RSA_key(id, msg,new Integer(category).toString());
			//String enc_key=null;
			if((enc_key!=null && enc_key.equals(key))||true){
				
			
			
			String temp_pass=null;
			int temp_category=-1;
			String temp_jno=null;
			String temp_query=null;
			
			if(category>0 && category<4)
			{
				temp_query=query1;
			}
			else if(category==0)
				temp_query=query2;
			else if(category==4 || category==5)
				temp_query=query3;
			
			try{
				stmt=conn.prepareStatement(temp_query);
				stmt.setString(1,id);
				
			if(category>0 && category<4)
			{	stmt.setInt(2, category);
				rs=stmt.executeQuery();
			while(rs.next())
			{
				temp_pass=rs.getString(1);
				temp_category=rs.getInt(2);
				temp_jno=rs.getString(3);
			}
			}
			else if(category==0)
			{
				rs=stmt.executeQuery();
			if(rs.next())
			{
				temp_pass=rs.getString(1);
				temp_category=category;
				
			}
			}
			
			if(category==4 || category==5)
			{
			stmt.setInt(2,category);
			rs=stmt.executeQuery();
			while(rs.next())
			{
				temp_pass=rs.getString(1);
				temp_category=rs.getInt(2);
				
			}
			} 
			
			
			}catch(Exception e){
				response.getWriter().println(e);
			}
	
			
			if((pwd.equals(temp_pass) && category==temp_category))
			{
				loginbean.setId(id);
				loginbean.setNo(1);
				loginbean.setCategory(category);
			try{
				String date="",time="";
				String log="User Id:"+id+"<br/><ul><li>Logged In</li>";
				stmt=conn.prepareStatement("select Current date,Current time from sch1.jail");
				ResultSet rs=stmt.executeQuery();
				if(rs.next())
				{
					date=rs.getString(1);
					time=rs.getString(2);
				}
				stmt=conn.prepareStatement(query4);
				stmt.setString(1,id);
				stmt.setString(2, date);
				stmt.setString(3, time);
				stmt.setInt(4, category);
				stmt.executeUpdate();
				conn.close();
				loginbean.setLog(log);
				loginbean.setDate(date);
				loginbean.setTime(time);
				//loginbean.setLog(log);
				
				loginbean.setTimer(new java.util.Date().getTime());
			}
			catch(Exception e){
				response.getWriter().write("<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;There May Be Error With Our DataBase<br/> Server</span>"+e.toString());
			
			}
				if(temp_category==0 || temp_category==4 ||temp_category==5)loginbean.setJno("!--1233--*&-");
				else loginbean.setJno(temp_jno);
				response.getWriter().println("success "+id);
				
				RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/finishlogin.jsp");
				dispatcher.forward(request,response);

			}
			else
			{
				
				loginbean.setId(null);
				RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/login_fail.jsp");
				dispatcher.forward(request,response);

			 
			}
			}else
			{
			
				loginbean.setId(null);
				RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/login_fail.jsp");
				dispatcher.forward(request,response);

			}
		}
	}   	  	    
}