package com.servlet;



import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.HashMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;

/**
 * Servlet implementation class Runner
 */
public class Reporter extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
	
	Connection conn;
	PreparedStatement stmt;
	boolean failure=false;
	String jno="";
	String jailno,id,name,type="Bar Chart";
	int category;
	String fundin="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE jasperReport PUBLIC \"//JasperReports//DTD Report Design//EN\" \"http://jasperreports.sourceforge.net/dtds/jasperreport.dtd\">\n<jasperReport name=\"fundin\">\n<queryString>\n<![CDATA[(select amount,year,jno,'JAIL NO='||jno as jno1 from sch3.fund_in_admin)]]>\n</queryString>\n<field name=\"jno1\" class=\"java.lang.String\"/>\n<field name=\"jno\" class=\"java.lang.String\"/>\n<field name=\"amount\" class=\"java.lang.Integer\"/>\n<field name=\"year\" class=\"java.lang.Integer\"/>\n<group name=\"modelGroup\">\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height=\"750\">\n<barChart>\n<chart evaluationTime=\"Report\">\n<reportElement x=\"0\" y=\"0\" width=\"555\" height=\"350\"/>\n</chart>\n<categoryDataset>\n<dataset incrementType=\"None\"/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{year}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{amount}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks=\"false\">\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	
	
		
	String paroleperyear="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN'  'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='paroleperyear'>\n<queryString>\n<![CDATA[(select count,year,jno,'JAIL NO='||jno as jno1 from sch3.parole_year_admin)]]>\n</queryString>\n<field name='jno1' class='java.lang.String'/>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{year}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String menprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='menprisonerinstate'>\n<queryString>\n<![CDATA[(select count,year,state from sch3.men_state_admin)]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{state}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{year}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String parolepermonth="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='parolepermonth'>\n<queryString>\n<![CDATA[(select count,month,jno,'JAIL NO='||jno as jno1 from sch3.parole_month_admin)]]>\n</queryString>\n<field name='jno1' class='java.lang.String'/>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='month' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{month}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{month}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String menprisoner="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='menprisoner'>\n<queryString>\n<![CDATA[(select count,year,jno,'JAIL NO='||jno as jno1 from sch3.prisoner_men_admin)]]>\n</queryString>\n<field name='jno1' class='java.lang.String'/>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{year}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String womenprisoner="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='womenprisoner'>\n<queryString>\n<![CDATA[(select count,year,jno,'JAIL NO='||jno as jno1 from sch3.prisoner_women_admin)]]>\n</queryString>\n<field name='jno1' class='java.lang.String'/>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{year}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String pieparolepermonth="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Pieparolepermonth'>\n<!--<title>\n<band height='50'>\n<staticText>\n<reportElement x='180' y='0' width='200' height='20'/>\n<text>\n<![CDATA[COUNT OF PRISONER vs MONTH FOR THIS JAIL]]>\n</text>\n</staticText>\n</band>\n</title>\n-->\n<queryString>\n<![CDATA[select count,month from sch3.parole_month_admin]]>\n</queryString>\n<field name='month' class='java.lang.Integer'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{month}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{month}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	String piemenprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piemenprisonerinstate'>\n<queryString>\n<![CDATA[(select count,year,state from sch3.men_state_admin)]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{state}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String piemenprisoner="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piemenprisoner'>\n<!--<title>\n<band height='50'>\n<staticText>\n<reportElement x='180' y='0' width='200' height='20'/>\n<text>\n<![CDATA[COUNT OF MALE PRISONER vs YEAR FOR THIS JAIL]]>\n</text>\n</staticText>\n</band>\n</title>\n-->\n<queryString>\n<![CDATA[select count,year from sch3.prisoner_men_admin]]>\n</queryString>\n<field name='year' class='java.lang.Integer'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{year}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	String piefundin="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piefundin'>\n<queryString>\n<![CDATA[select amount,year from sch3.fund_in_admin]]>\n</queryString>\n<field name='year' class='java.lang.Integer'/>\n<field name='amount' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{year}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{amount}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String pieparoleperyear="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Pieparoleperyear'>\n<!--<title>\n<band height='50'>\n<staticText>\n<reportElement x='180' y='0' width='200' height='20'/>\n<text>\n<![CDATA[COUNT OF PRISONER vs YEAR FOR THIS JAIL]]>\n</text>\n</staticText>\n</band>\n</title>\n-->\n<queryString>\n<![CDATA[select count,year from sch3.parole_year_admin]]>\n</queryString>\n<field name='year' class='java.lang.Integer'/>\n<field name='count' class='java.lang.Integer'/>\n<!--<variable name='totalAircraft' class='java.lang.Integer'calculation='Count' resetType='Group'resetGroup='modelGroup'>\n<variableExpression>\n<![CDATA[$F{model}]]>\n</variableExpression>\n<initialValueExpression>\n<![CDATA[new java.lang.Integer(0)]]>\n</initialValueExpression>\n</variable>\n-->\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{year}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String pieprisoneragechild="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Pieprisoneragechild'>\n<queryString>\n<![CDATA[select count,year from sch3.prisoner_child_admin where age<=14]]>\n</queryString>\n<field name='year' class='java.lang.Integer'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{year}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String pietotprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Pietotprisonerinstate'>\n<queryString>\n<![CDATA[select count,state from sch3.tot_state_admin]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{state}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String piewomenprisoner="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piewomenprisoner'>\n<!--<title>\n<band height='50'>\n<staticText>\n<reportElement x='180' y='0' width='200' height='20'/>\n<text>\n<![CDATA[COUNT OF FEMALE PRISONER vs YEAR FOR THIS JAIL]]>\n</text>\n</staticText>\n</band>\n</title>\n-->\n<queryString>\n<![CDATA[select count,year from sch3.prisoner_women_admin]]>\n</queryString>\n<field name='year' class='java.lang.Integer'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{year}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String piewomenprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piewomenprisonerinstate'>\n<queryString>\n<![CDATA[(select count,year,state from sch3.women_state_admin)]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{state}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	String prisoneragechild="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='prisoneragechild'>\n<queryString>\n<![CDATA[(select count,year,jno,'JAIL NO='||jno as jno1 from sch3.prisoner_child_admin where age<=14)]]>\n</queryString>\n<field name='jno1' class='java.lang.String'/>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{year}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{year}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno1}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String totprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='totprisonerinstate'>\n<queryString>\n<![CDATA[(select count,year,state from sch3.tot_state_admin)]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{state}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{year}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	String womenprisonerinstate="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='womenprisonerinstate'>\n<queryString>\n<![CDATA[(select count,year,state from sch3.women_state_admin)]]>\n</queryString>\n<field name='state' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{state}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{state}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{year}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	String crimeinjail="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='crimeinjail'>\n<queryString>\n<![CDATA[(select count,crime,jno from sch3.crime_rep1)]]>\n</queryString>\n<field name='jno' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='crime' class='java.lang.String'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{crime}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{crime}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{jno}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>";
	String overallcrime="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='overallcrime'>\n<queryString>\n<![CDATA[(select count,crime,nation from sch3.crime_rep)]]>\n</queryString>\n<field name='nation' class='java.lang.String'/>\n<field name='count' class='java.lang.Integer'/>\n<field name='crime' class='java.lang.String'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{crime}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{crime}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{nation}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>";
	String piecrimeinjail="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piecrimeinjail'>\n<queryString>\n<![CDATA[select count,crime from sch3.crime_rep1]]>\n</queryString>\n<field name='count' class='java.lang.Integer'/>\n<field name='crime' class='java.lang.String'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{crime}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{crime}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>";	
	String pieoverallcrime="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Pieoverallcrime'>\n<queryString>\n<![CDATA[select count,crime from sch3.crime_rep]]>\n</queryString>\n<field name='count' class='java.lang.Integer'/>\n<field name='crime' class='java.lang.String'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{crime}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{crime}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{count}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>";
	
	String fundinalljail="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='fundinalljail'>\n<queryString>\n<![CDATA[(select amount,year,jno from sch3.fund_injail_admin)]]>\n</queryString>\n<field name='jno' class='java.lang.String'/>\n<field name='amount' class='java.lang.Integer'/>\n<field name='year' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{jno}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<barChart>\n<chart evaluationTime='Report'>\n<reportElement x='0' y='0' width='555' height='350'/>\n</chart>\n<categoryDataset>\n<dataset incrementType='None'/>\n<categorySeries>\n<seriesExpression>\n<![CDATA[$F{jno}]]>\n</seriesExpression>\n<categoryExpression>\n<![CDATA[$F{year}]]>\n</categoryExpression>\n<valueExpression>\n<![CDATA[$F{amount}]]>\n</valueExpression>\n</categorySeries>\n</categoryDataset>\n<barPlot isShowTickMarks='false'>\n<plot/>\n</barPlot>\n</barChart>\n</band>\n</summary>\n</jasperReport>\n";
	String piefundinalljail="<?xml version='1.0' encoding='UTF-8'?>\n<!DOCTYPE jasperReport PUBLIC '//JasperReports//DTD Report Design//EN' 'http://jasperreports.sourceforge.net/dtds/jasperreport.dtd'>\n<jasperReport name='Piefundinalljail'>\n<queryString>\n<![CDATA[select amount,year,jno from sch3.fund_injail_admin]]>\n</queryString>\n<field name='jno' class='java.lang.String'/>\n<field name='year' class='java.lang.Integer'/>\n<field name='amount' class='java.lang.Integer'/>\n<group name='modelGroup'>\n<groupExpression>\n<![CDATA[$F{jno}]]>\n</groupExpression>\n</group>\n<summary>\n<band height='750'>\n<pieChart>\n<chart evaluationTime='Report'>\n<reportElement x='135' y='0' width='270' height='350'/>\n</chart>\n<pieDataset>\n<dataset incrementType='None'/>\n<keyExpression>\n<![CDATA[$F{jno}]]>\n</keyExpression>\n<valueExpression>\n<![CDATA[$F{amount}]]>\n</valueExpression>\n</pieDataset>\n<piePlot>\n<plot/>\n</piePlot>\n</pieChart>\n</band>\n</summary>\n</jasperReport>\n";
	
	
	 
	
	   
	
	
	
 
	//Jail Admin
	
	String view_name[]={"sch3.fund_in_admin","sch3.prisoner_men_admin","sch3.parole_year_admin","sch3.prisoner_women_admin","sch3.parole_month_admin","sch3.prisoner_child_admin","sch3.fund_injail_admin","sch3.women_state_admin","sch3.men_state_admin","sch3.tot_state_admin","sch3.crime_rep1","sch3.crime_rep"};
	
	

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		try{
			
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			conn = DriverManager.getConnection("jdbc:db2://localhost:50000/PRISIONM:retrieveMessagesFromServerOnGetMessage=true;","inst","sister");
					
			}
		catch(Exception e)
		{
		failure = true;	
		}
 

		
		
		
		int choice,pie;
		String temp_query="",temp_file="",temp_file1="";
		Statement stmt1=null;
		
		
		
		
		
		PrintWriter pw=response.getWriter();
		
		choice=Integer.parseInt(request.getParameter("choice"));
		pie=Integer.parseInt(request.getParameter("pie"));
		
		HttpSession session;
		session=request.getSession();
		com.bean.LogonBean loginbean;
		loginbean=(com.bean.LogonBean)session.getAttribute("loginbean");
		if(loginbean.getJno()!=null && (loginbean.getCategory()==5 || loginbean.getCategory()==2)) 
		{
		jno=loginbean.getJno();
		}
		category=loginbean.getCategory();
		if(category!=2)
			jailno="not bound to any jail";
		else 
			jailno=loginbean.getJno();
		id=loginbean.getId();
		
		//choice=5;
		//jno="5";
		
		String query1="create view sch3.fund_in_admin(amount,year,jno) as select sum(amount),finyear,jno from sch1.fund_in group by finyear,jno having jno='"+jno+"'";
		String query2="create view sch3.parole_year_admin(count,jno,year) as select count(id),jno,year(outdate) from sch1.parole_reg group by jno,year(outdate) having jno='"+jno+"'";
		String query3="create view sch3.parole_month_admin(count,jno,month)as select count(id),jno,month(outdate) from sch1.parole_reg where year(outdate)=year(Current date) group by jno,month(outdate) having jno='"+jno+"'";
		String query4="create view sch3.prisoner_men_admin(count,jno,gender,year) as select count(e2.pid),e2.jno,e1.gender,year(e2.indate) from sch1.prisoner_bio e1,sch1.prisioner e2 where e1.pid=e2.pid group by e2.jno,e1.gender,year(e2.indate) having e2.jno='"+jno+"' and e1.gender='male'";
		String query5="create view sch3.prisoner_women_admin(count,jno,gender,year) as select count(e2.pid),e2.jno,e1.gender,year(e2.indate) from sch1.prisoner_bio e1,sch1.prisioner e2 where e1.pid=e2.pid group by e2.jno,e1.gender,year(e2.indate) having e2.jno='"+jno+"' and e1.gender='female'";
		String query6="create view sch3.prisoner_child_admin(count,jno,age,year) as select count(e2.pid),e2.jno,year(Current date-e1.pdob),year(e2.indate) from sch1.prisoner_bio e1,sch1.prisioner e2 where e1.pid=e2.pid group by e2.jno,year(e2.indate),year(Current date-e1.pdob) having e2.jno='"+jno+"'";
		//Common User
		String query7="create view sch3.fund_injail_admin(amount,year,jno) as select sum(amount),finyear,jno from sch1.fund_in group by finyear,jno having finyear=year(Current Date)";
		
		String query8="create view sch3.women_state_admin(count,jno,gender,year,state)as select count(e2.pid),e2.jno,e1.gender,year(e2.indate),e3.state from sch1.prisoner_bio e1,sch1.prisioner e2,sch1.jail e3 where e3.jailno=e2.jno and e2.pid=e1.pid group by e3.state,e2.jno,e1.gender,year(e2.indate) having  e1.gender='female' and year(e2.indate)=year(Current date)";
		String query9="create view sch3.men_state_admin(count,jno,gender,year,state)as select count(e2.pid),e2.jno,e1.gender,year(e2.indate),e3.state from sch1.prisoner_bio e1,sch1.prisioner e2,sch1.jail e3 where e3.jailno=e2.jno and e2.pid=e1.pid group by e3.state,e2.jno,e1.gender,year(e2.indate) having  e1.gender='male' and year(e2.indate)=year(Current date)";
		//String query10="create view sch3.tot_state_admin(count,jno,gender,year,state)as select count(e2.pid),e2.jno,e1.gender,year(e2.indate),e3.state from sch1.prisoner_bio e1,sch1.prisioner e2,sch1.jail e3 where e3.jailno=e2.jno and e2.pid=e1.pid group by e3.state,e2.jno,e1.gender,year(e2.indate) having year(e2.indate)=year(Current date)";
		String query10="create view sch3.tot_state_admin(count,jno,year,state)as select count(e2.pid),e2.jno,year(e2.indate),e3.state from sch1.prisoner_bio e1,sch1.prisioner e2,sch1.jail e3 where e3.jailno=e2.jno and e2.pid=e1.pid group by e3.state,e2.jno,year(e2.indate) having year(e2.indate)=year(Current date)";
		String query11="create view sch3.crime_rep1(count,crime,jno) as select count(*),crime,'jno='||jno from sch1.prisioner where year(indate)=year(Current date) and jno='"+jno+"' group by crime,jno";
		String query12="create view sch3.crime_rep(count,crime,nation) as select count(*),crime,year(Current date) from sch1.prisioner where year(indate)=year(Current date) group by crime";
		
		switch(choice)
		{
		case 1:
			temp_query=query1;
			temp_file="fundin";
			temp_file1=fundin;
			name="Fund In Report";
			if(pie==1){
				temp_file1=piefundin;
				type="Pie Chart";
			}		
			break;
		case 2:
			temp_query=query4;
			temp_file="menprisoner";
			temp_file1=menprisoner;
			name="Men Prisoner Per Year Report";
			if(pie==1){
				temp_file1=piemenprisoner;
				type="Pie Chart";
			}
			break;
		
		case 3:
			temp_query=query2;
			temp_file="paroleperyear";
			temp_file1=paroleperyear;
			name="Parole vs Year Report";
			if(pie==1){
				temp_file1=pieparoleperyear;
				type="Pie Chart";
			}
			break;
		case 4:
			temp_query=query5;
			temp_file="womenprisoner";
			temp_file1=womenprisoner;
			name="Women Prisoner Per Year";
			if(pie==1){
				temp_file1=piewomenprisoner;
				type="Pie Chart";
			}
			break;
		case 5:
			temp_query=query3;
			temp_file="parolepermonth";
			temp_file1=parolepermonth;
			name="Parole Vs Month Report";
			if(pie==1){
				temp_file1=pieparolepermonth;
				type="Pie Chart";
			}
			break;
		
		case 6:
			temp_query=query6;
			temp_file="prisoneragechild";
			temp_file1=prisoneragechild;
			name="Juvenile Prisoner Per Year";
			if(pie==1){
				temp_file1=pieprisoneragechild;
				type="Pie Chart";
			}
			break;
		case 7:
			temp_query=query7;
			temp_file="fundinalljail";
			temp_file1=fundinalljail;
			name="Cummilative Fund In Report";
			if(pie==1){
				temp_file1=piefundinalljail;
				type="Pie Chart";
			}
			break;
		case 8:
			temp_query=query8;
			temp_file="womenprisonerinstate";
			temp_file1=womenprisonerinstate;
			name="Women Prisoner State-Wise Report";
			if(pie==1){
				temp_file1=piewomenprisonerinstate;
				type="Pie Chart";
			}
			break;
		case 9:
			temp_query=query9;
			temp_file="menprisonerinstate";
			temp_file1=menprisonerinstate;
			name="Men Prisoner State-Wise Report";
			if(pie==1){
				temp_file1=piemenprisonerinstate;
				type="Pie Chart";
			}
			break;
		case 10:
			temp_query=query10;
			temp_file="totprisonerinstate";
			temp_file1=totprisonerinstate;
			name="Total Prisoner State-Wise Report";
			if(pie==1){
				temp_file1=pietotprisonerinstate;
				type="Pie Chart";
			}
			break;
		case 11:
			temp_query=query11;
			temp_file="crimeinjail";
			temp_file1=crimeinjail;
			name="Yearly Crime Report For The Jail";
			if(pie==1){
				temp_file1=piecrimeinjail;
				type="Pie Chart";
			}
			break;
		case 12:
			temp_query=query12;
			temp_file="overallcrime";
			temp_file1=overallcrime;
			name="Cummulative Yearly Crime Report";
			if(pie==1){
				temp_file1=pieoverallcrime;
				type="Pie Chart";
			}
			break;
		
		}
		
		if(pie==1)
			{
			temp_file="Pie"+temp_file;
			
				//temp_file1="pie"+temp_file1;
				
			}
		
		
	try{
		
		try{
			stmt1 = conn.createStatement();
			stmt1.executeUpdate("drop view "+view_name[choice-1]);
			
		}catch(Exception e){}
		
		PreparedStatement statm;
		String tempo_query;
		tempo_query="insert into sch2.report_log values(?,?,?,?,?,Current date,Current time)";
		statm = conn.prepareStatement(tempo_query);
		statm.setString(1,id );
		statm.setString(2,jailno );
		statm.setInt(3,category );
		statm.setString(4,name );
		statm.setString(5,type ); 
		statm.executeUpdate();
		stmt = conn.prepareStatement(temp_query);
		stmt.executeUpdate();

		BufferedWriter bw=new BufferedWriter(new FileWriter(System.getProperty("user.dir")+"/temp.jrxml"));
		bw.write(temp_file1);
		bw.close();
		
		JasperCompileManager.compileReportToFile(System.getProperty("user.dir")+"/temp.jrxml");
			
			JasperFillManager.fillReportToFile(System.getProperty("user.dir")+"/"+temp_file+".jasper",new HashMap(),conn);
			File file = new File(System.getProperty("user.dir")+"/"+temp_file+".jrprint");
			
			JasperPrint jasperPrint = (JasperPrint)
			JRLoader.loadObject(file);
			JRPdfExporter pdfExporter = new JRPdfExporter();
			pdfExporter.setParameter(JRExporterParameter.
			JASPER_PRINT, jasperPrint);
			
				
			
				
			stmt1 = conn.createStatement();
			stmt1.executeUpdate("drop view "+view_name[choice-1]);
			
			stmt.close();
			stmt1.close();
										
			
			stmt1 = conn.createStatement();
			String loc="";
			ResultSet rs=stmt1.executeQuery("select location from sch2.tracker");
				if(rs.next())loc=rs.getString(1);
			
				
				File f=new File(loc+"/jasper/"+temp_file+".pdf");
				if(f.exists())f.delete();
					
				pdfExporter.setParameter(JRExporterParameter.OUTPUT_FILE_NAME,loc+"/jasper/"+temp_file+".pdf");
				pdfExporter.exportReport();
				
				
				conn.close();
				pw.print("<b>To view The Report Click </b><i><a target='_blank' href='https://localhost:9445/ManageWEB/jasper/"+temp_file+".pdf"+"'>here</a></i>.");
				
				f=new File(System.getProperty("user.dir")+"/"+temp_file+".jasper");
				if(f.exists())f.delete();
				f=new File(System.getProperty("user.dir")+"/"+temp_file+".jrprint");
				if(f.exists())f.delete();
				
		}catch(Exception e)
		{
			pw.print("<b><font color='black'>ERROR:Causes May Be,</font></b><br/><span style='font-weight:none;'>1.&nbsp;Details Entered May Be Incorrect <br/> 2.&nbsp;There May Be Error With Our DataBase<br/> Server</span>"+e.toString());
			try{
			stmt.close();
			stmt1.close();
			conn.close();							
			}catch(Exception e1){}
		}	
		 
		
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	//protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
	//}

}
